Description

Hi,

I have some troubles loading QLR files with relative path. The path in the QLR is relative to the folder where the QLR file was saved which

is good but it seems QGIS considers the path relative to the folder where the QGS project is saved.

For examle when I try to load a QLR in:

- a new, blank and non saved project > it works

- a QGS project saved in the same folder than the QLR file > it works

- a QGS project saved in a different folder than the QLR file > it does not works

Associated revisions

Revision 533a8f8a - 2017-11-07 10:56 AM - René-Luc ReLuc

[PATCH] [BUGFIX] Load layer from definition does not use qlr as relative path

Fixes #15656 Loading QLR file with relative path does not work correctly

Revision ba71e79f - 2018-02-05 04:48 PM - René-Luc ReLuc

[BUGFIX] Load layer from definition does not use qlr as relative path

Fixes #15656 Loading QLR file with relative path does not work correctly

History

#1 - 2016-10-04 10:32 PM - Tudor Bărăscu

See http://docs.qgis.org/2.14/en/docs/user_manual/introduction/qgis_configuration.html#project-properties

You can choose between relative and absolute paths.

As you observed, QGIS considers the relative paths to the qgs project.

IMHO qlr is a definition of a layer to be used in the project. So, the datasource should be relative to the project and NOT to the qlr (which just defines the

path to the datasource from the project perspective).

Are you saying that you're loading in a project a qlr file and it works but after saving the project (without loading the qlr file afterwards) it doesn't work

anymore?

2025-04-27 1/3

http://docs.qgis.org/2.14/en/docs/user_manual/introduction/qgis_configuration.html#project-properties


#2 - 2016-10-05 01:02 AM - Dominique Lyszczarz

Actually when saving a QLR the datasource path is relative to QLR destination folder, not the QGS one.

It seems this behaviour was fixed in #10858

But on another hand when QGIS load a QLR it search the datasource with a path relative to the folder where the qgs is saved.

This inconsistency causes lot of troubles.

For example if I have a shapefile in the folder foo/data and a qgs project in the folder foo/qgs, load the shp and save a new QLR to foo/myqlr.qlr then just

trying to reopen this QLR and it does not find the datasource (there is no error message but the layer entry in the TOC is empty)

The path in the QLR is ./data/shapefile.shp which is correct (== foo/data/shapefile.shp) but I suspect QGIS search the source at

foo/qgs/data/shapefile.shp. If I just resave my project to /foo/myproject.qgs or if I change the path in the QLR to ../data/shapefile.shp, then I can load

correctly my QLR file.

#3 - 2016-12-01 12:04 AM - Juan Manuel Perez

I agree with Dominique. We hava also stumbled into some problems caused by that inconsistency he points out:

"When saving a QLR the datasource path is relative to QLR destination folder, not the QGS one. But, on another hand, when QGIS load a QLR it searchs

the datasource with a path relative to the folder where the QGS is saved" 

If this behaviour is to remain as it is now, then maybe it could be fair if we could have a warning telling the user that loading the generated QLR will fail

unless moved next to the QGS file.

#4 - 2017-05-01 01:03 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#5 - 2017-09-21 10:51 AM - Giovanni Manghi

- Category set to Project Loading/Saving

- Description updated

#6 - 2017-09-21 10:56 AM - Dominique Lyszczarz

- Status changed from Open to Closed

Tested on latest master, now it works correctly. Seems it was fixed a few months ago in commit:5f5c1ddb15c214a8a920ca6b34fab85dfab4f0a6

Thanks !

#7 - 2017-11-06 09:06 PM - René-Luc ReLuc

- Status changed from Closed to Reopened

- Assignee set to René-Luc ReLuc

- Affected QGIS version changed from 2.16.2 to 2.18.14

This issue has been fixed in master but not in LTR.
#8 - 2017-11-07 09:54 AM - René-Luc ReLuc

- Pull Request or Patch supplied changed from No to Yes

A Pull Request is opened https://github.com/qgis/QGIS/pull/5553

#9 - 2017-11-08 10:05 AM - René-Luc ReLuc

- Status changed from Reopened to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|533a8f8a4d018744541b35b388b060cb8a9e5499.
